import { Component, Emit, Prop, Vue, Watch } from 'vue-property-decorator';
import { Measure, MeasureConfig, MeasureType, Measurement, MeasurementMeta } from '@/models';
import SimpleEntry from './SimpleEntry.vue';
import TextEntry from './TextEntry.vue';

@Component({
  components: {
    SimpleEntry,
    TextEntry
  }
})
export class MeasurementEntry extends Vue {
  @Prop() private measure!: Measure<MeasureConfig>;
  @Prop() private value!: Measurement<MeasurementMeta>;

  @Watch('value', { immediate: true, deep: true })
  @Emit('input')
  private onMeasurementChanged(newVal: Measurement<MeasurementMeta>, oldVal: Measurement<MeasurementMeta>) {
    newVal.measureId = this.measure.id;
    return newVal;
  }

}

export default MeasurementEntry;
